// 22 02 2015 version beta2 qui permet de mesurer les tensions Va, Ve, Vg1 et les courants
// en sortie d'AOP OPA227 , soit Ia et Ie 

// Define various ADC prescaler
const unsigned char PS_16 = (1 << ADPS2);
const unsigned char PS_128 = (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
char Buf;   // 1 caractère
char Ligne[8];          // La ligne de stockage 8 caractères au maximum
int iCmde;    // un entier correspondant au n° de commande
float fCmde;  // une valeurs décimales négative ou positive
char valtxt1[3], valtxt2[5];
int i;
unsigned int Rapport_Cyclique;
unsigned int Rapport_Mesure;
// Pin 9 has Heater from TCT_Hardware connected for test.
// Pin 5 has a led for other test
// give it a name:
int Hfil = 9;
int Pol = 10;
int Gbias = 13;
int Va = 3;
int Dva = 0;
int Ve = 11;
int Dve = 1;
int Opta = 6;
int Opte = 5;
int Cig = 2;
int iVal;
// Variable for stored data
float fPower;
float fVoltage;
float fFill;
float fVamax;
float fVemax;
float fVacurrent;
float fBoosta;
float fVecurrent;
float fBooste;
float fPolmax;
float fPolvg1;
float fGbias;
int iPmwbias;
float fOpta;
float fMesht = 0;
int duty = 0;
int x;
int measure;
int measureva;
int measureve;
int measureia;
int measureie;
int measurevg;
int power_level = 0;
int power_levela = 0;
int power_levele = 0;

// Variable pour éditer les mesures

float fVg1;

void setup()
{
  // for Leonardo
  // The Leonardo has 7 PWM pins instead of 6. ATmega32U4 also has a new timer, timer4
  // which has 10 bits and uses a PLL to count at 64MHz. Their mappings are different as well:

  //  D3:  8-bit timer0
  //  D5:  16-bit timer1&3
  //  D6:  10-bit timer4
  //  D9:  16-bit timer1&3
  //  D10:  16-bit timer1&3
  //  D11:  8-bit timer0
  //  D13:  10-bit timer4
 
  // set the frequency to 62.5 Khz for the PWM on pin 3 et 11 with timer0
  // set the frequency to 31.2 Khz for the PWM on pin 9,10 with timer1
  // set the frequency to 3921 Hz for the PWM on pin 13 with timer4
  TCCR0B = TCCR0B & 0b11111000 | 0x01;
  TCCR1B = TCCR1B & 0b11111000 | B00000001;
  TCCR4B = TCCR4B & 0b11111000 | B00000010;

//For Arduino Mega1280, Mega2560, MegaADK, Spider or any other board using ATmega1280 or ATmega2560**
 
//---------------------------------------------- Set PWM frequency for D4 & D13 ------------------------------
 
//TCCR0B = TCCR0B & B11111000 | B00000001;    // set timer 0 divisor to     1 for PWM frequency of 62500.00 Hz
//TCCR0B = TCCR0B & B11111000 | B00000010;    // set timer 0 divisor to     8 for PWM frequency of  7812.50 Hz
//  TCCR0B = TCCR0B & B11111000 | B00000011;    // set timer 0 divisor to    64 for PWM frequency of   976.56 Hz (Default)
//TCCR0B = TCCR0B & B11111000 | B00000100;    // set timer 0 divisor to   256 for PWM frequency of   244.14 Hz
//TCCR0B = TCCR0B & B11111000 | B00000101;    // set timer 0 divisor to  1024 for PWM frequency of    61.04 Hz
 
 
//---------------------------------------------- Set PWM frequency for D11 & D12 -----------------------------
 
//TCCR1B = TCCR1B & B11111000 | B00000001;    // set timer 1 divisor to     1 for PWM frequency of 31372.55 Hz
//TCCR1B = TCCR1B & B11111000 | B00000010;    // set timer 1 divisor to     8 for PWM frequency of  3921.16 Hz
//  TCCR1B = TCCR1B & B11111000 | B00000011;    // set timer 1 divisor to    64 for PWM frequency of   490.20 Hz (Default)
//TCCR1B = TCCR1B & B11111000 | B00000100;    // set timer 1 divisor to   256 for PWM frequency of   122.55 Hz
//TCCR1B = TCCR1B & B11111000 | B00000101;    // set timer 1 divisor to  1024 for PWM frequency of    30.64 Hz
 
//---------------------------------------------- Set PWM frequency for D9 & D10 ------------------------------
 
//TCCR2B = TCCR2B & B11111000 | B00000001;    // set timer 2 divisor to     1 for PWM frequency of 31372.55 Hz
//TCCR2B = TCCR2B & B11111000 | B00000010;    // set timer 2 divisor to     8 for PWM frequency of  3921.16 Hz
//TCCR2B = TCCR2B & B11111000 | B00000011;    // set timer 2 divisor to    32 for PWM frequency of   980.39 Hz
//  TCCR2B = TCCR2B & B11111000 | B00000100;    // set timer 2 divisor to    64 for PWM frequency of   490.20 Hz (Default)
//TCCR2B = TCCR2B & B11111000 | B00000101;    // set timer 2 divisor to   128 for PWM frequency of   245.10 Hz
//TCCR2B = TCCR2B & B11111000 | B00000110;    // set timer 2 divisor to   256 for PWM frequency of   122.55 Hz
//TCCR2B = TCCR2B & B11111000 | B00000111;    // set timer 2 divisor to  1024 for PWM frequency of    30.64 Hz
 
 
//---------------------------------------------- Set PWM frequency for D2, D3 & D5 ---------------------------
 
//TCCR3B = TCCR3B & B11111000 | B00000001;    // set timer 3 divisor to     1 for PWM frequency of 31372.55 Hz
//TCCR3B = TCCR3B & B11111000 | B00000010;    // set timer 3 divisor to     8 for PWM frequency of  3921.16 Hz
//  TCCR3B = TCCR3B & B11111000 | B00000011;    // set timer 3 divisor to    64 for PWM frequency of   490.20 Hz (Default)
//TCCR3B = TCCR3B & B11111000 | B00000100;    // set timer 3 divisor to   256 for PWM frequency of   122.55 Hz
//TCCR3B = TCCR3B & B11111000 | B00000101;    // set timer 3 divisor to  1024 for PWM frequency of    30.64 Hz
 
 
//---------------------------------------------- Set PWM frequency for D6, D7 & D8 ---------------------------
 
//TCCR4B = TCCR4B & B11111000 | B00000001;    // set timer 4 divisor to     1 for PWM frequency of 31372.55 Hz
//TCCR4B = TCCR4B & B11111000 | B00000010;    // set timer 4 divisor to     8 for PWM frequency of  3921.16 Hz
//  TCCR4B = TCCR4B & B11111000 | B00000011;    // set timer 4 divisor to    64 for PWM frequency of   490.20 Hz (Default)
//TCCR4B = TCCR4B & B11111000 | B00000100;    // set timer 4 divisor to   256 for PWM frequency of   122.55 Hz
//TCCR4B = TCCR4B & B11111000 | B00000101;    // set timer 4 divisor to  1024 for PWM frequency of    30.64 Hz
 
 
//---------------------------------------------- Set PWM frequency for D44, D45 & D46 ------------------------
 
//TCCR5B = TCCR5B & B11111000 | B00000001;    // set timer 5 divisor to     1 for PWM frequency of 31372.55 Hz
//TCCR5B = TCCR5B & B11111000 | B00000010;    // set timer 5 divisor to     8 for PWM frequency of  3921.16 Hz
//  TCCR5B = TCCR5B & B11111000 | B00000011;    // set timer 5 divisor to    64 for PWM frequency of   490.20 Hz (Default)
//TCCR5B = TCCR5B & B11111000 | B00000100;    // set timer 5 divisor to   256 for PWM frequency of   122.55 Hz
//TCCR5B = TCCR5B & B11111000 | B00000101;    // set timer 5 divisor to  1024 for PWM frequency of    30.64 Hz
 
  Serial.begin(115200);
  pinMode(Hfil, OUTPUT); 
  pinMode(Va, OUTPUT);
  pinMode(Dva, OUTPUT);
  pinMode(Ve, OUTPUT);
  pinMode(Dve, OUTPUT);
  pinMode(Pol, OUTPUT);
  pinMode(Gbias, OUTPUT);
  pinMode(Opta, OUTPUT);
  pinMode(Opte, OUTPUT);
  pinMode(Cig,OUTPUT);
  //analogWrite(Opta,255);
  //analogWrite(Opte,255);
  
  // set up the ADC
  ADCSRA &= ~PS_128;  // remove bits set by Arduino library
  // you can choose a prescaler 
  ADCSRA |= PS_16;    
  // set our own prescaler to 16 
  Rapport_Cyclique = 0;
  
  
}


void loop()
{
  while (Serial.available())   
  {
    Buf = Serial.read();
    //Serial.println(Buf); 
    Ligne[i] = Buf; 
    i++;

    if (Buf == '\n')   
    { 
      Ligne[i] = '\0';

      sscanf(Ligne, "%s %s", &valtxt1, &valtxt2);

      iCmde = atoi(valtxt1);
      fCmde = atof(valtxt2);

      i = 0;

      switch (iCmde) {
      case 1:
        fPower=fCmde;
        Serial.println(fPower);
        break;
        
      case 2:
        Rapport_Cyclique = (fCmde/fPower)*255;
        //iVal = analogRead(A0);
        //Serial.println(iVal);
        //Serial.println(Rapport_Cyclique);
        analogWrite(Hfil,Rapport_Cyclique);     // met à jour la nouvelle valeur du rapport cyclique
        delay(500000);
        iVal = analogRead(A0);
        // Convert the analog reading (which goes from 0 - 1023) to a voltage (0 - 20V):
        // 0.02456; valeur initiale car 20.34 donne 825 à la mesure de A0
        fVoltage = iVal * 0.02456;
        //Serial.println(fVoltage);
        // convert the value you read:
        Rapport_Mesure = (fCmde/fVoltage)*255;
        //Serial.println(Rapport_Mesure);
        analogWrite(Hfil,Rapport_Mesure);     // met à jour la nouvelle valeur du rapport cyclique
        
        // Envoi un message à Processing
        
        //Serial.print("M,");
        //Serial.print(fPower);
        //Serial.print(",");
        //Serial.print(fVoltage);
        //Serial.print(",\n");
        
        break;
        
      case 3:
        fVamax=fCmde;
        break;
        
      case 4:
        fVemax=fCmde;
        break;
        
      case 5:
        fVacurrent = fCmde;
        fBoosta = fVacurrent*0.55;
        break;
        
      case 6:
        fVecurrent = fCmde;
        fBooste = fVecurrent*0.55;  
        break;
        
      case 7:
        fFill = analogRead(A0)*0.02466;
        power_levela = (fVacurrent+fFill)*2.68;
        power_levele = (fVecurrent+fFill)*2.85;
        
        measureva = analogRead(A1);
        if (measureva>power_levela){
          do {
          digitalWrite(Dva,HIGH);
          delay(100);
          digitalWrite(Dva,LOW);
          measureva = analogRead(A1);
          }while (measureva>(power_levela));
        }
        else {
         do {
        
           analogWrite(Va,fBoosta);
           delay(100);
           analogWrite(Va,0);
           measureva = analogRead(A1);

           }while (measureva<power_levela);
        }
        measureve = analogRead(A2);
        if (measureve>power_levele){
          do {
          digitalWrite(Dve,HIGH);
          delay(100);
          digitalWrite(Dve,LOW);
          measureve = analogRead(A2);
          }while (measureve>(power_levele));
        }
        else {
         do {
        
           analogWrite(Ve,fBooste);
           delay(100);
           analogWrite(Ve,0);
           measureve = analogRead(A2);

           }while (measureve<power_levele);
        }
          mesure();        
        break;
        
      case 8: // Vide les boosters
        do {
          digitalWrite(Dva,HIGH);
          delay(100);
          digitalWrite(Dva,LOW);
          measure = analogRead(A1);
          }while (measure>53);
        do {
          digitalWrite(Dve,HIGH);
          delay(100);
          digitalWrite(Dve,LOW);
          measure = analogRead(A2);
          }while (measure>53);
          
        break;        
      
      case 9:
        fPolvg1 = fCmde; // fixe la polarisation à appliquer au tube
        
        fFill = analogRead(A0)*0.02466;
        //analogWrite(Hfil,0);
        measure = analogRead(A11);
        //analogWrite(Hfil,Rapport_Mesure);
        fPolmax=1;
        fGbias = 40-fPolvg1;
        //fVg1 = ((1006-measure)*-0.1299)+((fPower-fFill));
        
        
        do {
          analogWrite(Pol,fPolmax);
          analogWrite(Gbias,fGbias);
          //analogWrite(Hfil,0);
          measure = analogRead(A11);
          //analogWrite(Hfil,Rapport_Mesure);
          fVg1 = ((1006-measure)*-0.1299)+((fPower-fFill));
          fPolmax++;
            
           //Serial.print(fGbias);
           //Serial.print(", ");
           //Serial.print(fPolmax);
           //Serial.print("\n");
          if (fPolmax>140){
           fGbias++;
          }
          else if (fPolmax>250){
            fGbias = (fGbias + 2);
          }
           }while (fVg1>fPolvg1);         
                     
        break;
        
        case 10:
        Serial.println("F,");
        break;

      default: 
        // if nothing else matches, do the default
        // default is optional
        break;
      }


    }

  }


}

// This function for read the analog voltage and send the data 
void mesure () {

  
        //analogWrite(Hfil,0);
        //analogWrite(Pol,0);
        
        Serial.print("M,");
           
        fFill = analogRead(A0)*0.02466;
        
        measurevg = analogRead(A11);
        measureva = analogRead(A1);
        measureve = analogRead(A2);
                
        digitalWrite(Dva,HIGH);
        digitalWrite(Dve,HIGH);
        delay(50);
        digitalWrite(Dva,LOW);
        digitalWrite(Dve,LOW);
        analogWrite(Opta,255);
        measureia = analogRead(A3);
        analogWrite(Opta,0);
        analogWrite(Opte,255);
        measureie = analogRead(A5);
        analogWrite(Opte,0);
        
        //measurevg = analogRead(A11);
        
        Serial.print(int(((measureva*0.3862)-fFill)+1));
        Serial.print(",");
        
        Serial.print(int(((measureve*0.3465)-fFill)+1));
        Serial.print(",");
                        
        Serial.print(int(measureia*0.2810));
        Serial.print(",");
        
        Serial.print(int(measureie*0.2810));
        Serial.print(",");
        
        
        fVg1 = ((1006-measurevg)*-0.1299)+((fPower-fFill));
        Serial.print(int(fVg1));
        Serial.println(",");
        
        
        //analogWrite(Pol,fPolmax);
        //analogWrite(Hfil,Rapport_Mesure);
}


